/**
* Objetos da classe Tempo encapsulam um valor de tempo, no estilo europeu (24 horas)
* O valor consiste de horas, minutos e segundos.
* A faixa de valores possível é 00:00:00 (meia-noite) até 23:59:59 (um segundo para meia-noite)
*
* @version 1.0
*/

public class Tempo {
	
	//os atributos que representam as três partes do tempo
	private int horas;
	private int minutos;
	private int segundos;
	
	
	/**
	 * Primeiro construtor da classe tempo
	 * Cria um novo objeto da classe tempo com o valor 00:00:00
	 */
	public Tempo() {
		horas = 0;
		minutos = 0;
		segundos = 0;
	}
	
	
	/**
	 * Segundo construtor da classe tempo
	 * Cria um novo objeto da classe tempo com o valor 00:00:00
	 * Assume, sem checar, que os parâmetros são válidos!
	 * Para este construtor, não é necessário preocupar-se com a validade dos parâmetros
	 */
	public Tempo(int horas, int minutos, int segundos) {
		this.horas = horas;
		this.minutos = minutos;
		this.segundos = segundos;
	}
	
	
	public void tique() {
		
	}
	
	
	public Tempo adicionarTempo(Tempo tempo) {
		return null;
	}
	

	public Tempo subtrairTempo(Tempo tempo) {
		return null;
	}
	
	
	
	/*********************************************************************************************
	 ******************** NÃO ALTERE QUALQUER TRECHO DE CÓDIGO A PARTIR DAQUI ********************
	 *********************************************************************************************/
	
	/**
	 * Sobrescrevendo o método equals
	 * Compara o Tempo atual com outroTempo.
	 * Retorna true se o Tempo da classe atual é IGUAL ao outroTempo, e false caso contrário.
	 */
	@Override
	public boolean equals(Object outroTempo) {
		if (outroTempo == null)
			return false;
		
		Tempo t = (Tempo)outroTempo;
		if ((this.horas == t.getHoras()) && 
				(this.minutos == t.getMinutos()) && 
				(this.segundos == t.getSegundos()))
			return true;
		else
			return false;
	}
	
	
	/**
	* Retorna uma string que representa o tempo no formato HH:MM:SS
	* 
	*/
	@Override
	public String toString() {
		return preenche(horas) + ":" + preenche(minutos) + ":" + preenche(segundos);
	}
	
	
	/**
	* Retorna uma string representando um argumento válido, adicionando o deslocamento "0"
	* "0" se necessário, para o valor da hora, minuto ou segundo ter dois dígitos
	*/
	private String preenche(int valor) {
		String sinal = "";
		if (valor < 0) {
			sinal = "-";
			valor = -valor;
		}
		if (valor < 10) {
			return sinal + "0" + valor;
		} else {
			return sinal + valor;
		}
	}


	public int getHoras() {
		return horas;
	}
	
	public void incHoras() {
		this.horas++;
	}
	
	public void incHoras(int horas) {
		this.horas += horas;
	}
	
	public void decHoras() {
		this.horas--;
	}
	
	public void decHoras(int horas) {
		this.horas -= horas;
	}


	public int getMinutos() {
		return minutos;
	}
	
	public void incMinutos() {
		this.minutos++;
	}
	
	public void incMinutos(int minutos) {
		this.minutos += minutos;
	}
	
	public void decMinutos() {
		this.minutos--;
	}
	
	public void decMinutos(int minutos) {
		this.minutos -= minutos;
	}


	public int getSegundos() {
		return segundos;
	}
	
	public void incSegundos() {
		this.segundos++;
	}
	
	public void incSegundos(int segundos) {
		this.segundos += segundos;
	}
	
	public void decSegundos() {
		this.segundos--;
	}
	
	public void decSegundos(int segundos) {
		this.segundos -= segundos;
	}
}
